import {
  Loader,
  Metadata,
  IDictionary,
} from '@zeedhi/core';

import { GridEditable } from '@zeedhi/common';
  
export class Ger21000FormasApresentacaoController {
  public gridEditController = Loader.getInstance('GridEditableController');

  public crudController = Loader.getInstance('CrudController');

  public utilities = Loader.getInstance('Utilities');

  public formatCode() {
    const grid: GridEditable = Metadata.getInstance('grid');
    const editedRows = grid.getEditedRows(false, true);

    if (grid.isGridValid(true) && editedRows.length > 0) {
      editedRows.forEach((row: IDictionary) => {
        row.CDAPRERECE = row.CDAPRERECE.padStart(3, '0');
      });
      // grid.datasource.loading = true;
      this.crudController.saveRows(editedRows, 'formaapresentacao', grid).then(() => {
        this.utilities.showAlert('alert', 'Salvo com sucesso!', 'success');
      }).catch((error: string) => {
        this.utilities.showAlert('alert', `pme::${error}`, 'error');
      }).finally(() => {
        this.gridEditController.defaultState(grid);
      });
    }
  }
}
