import {
  Loader, Metadata,
} from '@zeedhi/core';

import { GridEditable } from '@zeedhi/common';

export class Pla15100FormasPreparoController {
  public gridEditController = Loader.getInstance('GridEditableController');

  public crudController = Loader.getInstance('CrudController');

  public utilities = Loader.getInstance('Utilities');
  
  public saveFormaPrep() {
    const grid: GridEditable = Metadata.getInstance('gridFormaPreparo');
    const editedRows = grid.getEditedRows(false, true);

    if (grid.isGridValid(true) && editedRows.length > 0) {
      this.crudController.saveRows(editedRows, 'formaPreparo', grid).then(() => {
        this.utilities.showAlert('alert', 'Salvo com sucesso!', 'success');
      }).catch((error: string) => {
        this.utilities.showAlert('alert', `pme::${error}`, 'error');
      }).finally(() => {
        this.gridEditController.defaultState(grid);
      });
    }
  }
}
